import * as _WidgetBase from "dijit/_WidgetBase";
import * as Stateful from "dojo/Stateful";

export interface IRemovable {
    remove(): void;
}

type StatefulAttrs<T> = T extends Stateful<infer A> ? A : never;

interface WatchFn {
    <T extends Stateful, K extends keyof StatefulAttrs<T>>(
        target: T,
        prop: K,
        render: (model: StatefulAttrs<T>[K]) => any,
        own?: (obj: IRemovable) => void
    );
    <W extends _WidgetBase, K extends keyof W>(
        target: W,
        prop: K,
        render: (model: W[K]) => any,
        own?: (obj: IRemovable) => void
    );
}

export declare const watch: WatchFn;
